unit FXItem;

interface

uses
	 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
	 KMCustomItem, KMTimeLineTypes;

type
	TFXItem = class(TKMCustomItem)
	private
		{ Private declarations }
	protected
		{ Protected declarations }
	public
		{ Public declarations }
		constructor Create(AOwner: TComponent); override; 
		constructor CreateEx(AOwner: TComponent; theDur: TSeconds);
		destructor	Destroy; override;
		function ProcessEffect(theOutImg: TBitmap; Item1, Item2: TKMCustomItem; theTime: TSeconds): Boolean;
	published
		{ Published declarations }
	end;

implementation

{$R FXItem.res}

{$INCLUDE KMTrackTypes.inc}

constructor TFXItem.Create(AOwner: TComponent);
var
	tmpB: TBitmap;
begin
	inherited;
	tmpB := TBitmap.Create;
	tmpB.LoadFromResourceName(HInstance, 'FXIMAGE');
	Image := tmpB;
	tmpB.Free;
	//
	FKMTrackTypeID := c_id_Effects;
end;

constructor TFXItem.CreateEx(AOwner: TComponent; theDur: TSeconds);
var
	tmpB: TBitmap;
begin
	inherited CreateEx(AOwner, theDur);
	//
	tmpB := TBitmap.Create;
	tmpB.LoadFromResourceName(HInstance, 'FXIMAGE');
	Image := tmpB;
	tmpB.Free;
	//
	FKMTrackTypeID := c_id_Effects;
end;

destructor	TFXItem.Destroy;
begin
	inherited;
end;

function TFXItem.ProcessEffect(theOutImg: TBitmap; Item1, Item2: TKMCustomItem; theTime: TSeconds): Boolean;
const bSave: Boolean = false;
var
	tmpBmp: TBitmap;
	fDeg: double;
	srcR, dstR: TRect;
	
begin
	result := false;
	if (not Assigned(theOutImg)) then Exit;
	//
	if ((Duration = 0) or (theTime < 0) or (theTime > Duration)) then Exit;
	//
	theOutImg.Canvas.Brush.Color := clBlack;
	theOutImg.Canvas.FillRect(Rect(0, 0, theOutImg.Width, theOutImg.Height));
	//
	fDeg := theTime / Duration;
	//
	tmpBmp := TBitmap.Create;
	try
		//
		if (Assigned(Item2) and Assigned(Item2.Image)) then begin
			tmpBmp.Assign(Item2.Image);
			tmpBmp.PixelFormat := theOutImg.PixelFormat;
			dstR := Rect(0, 0, Round(theOutImg.Width*fDeg), theOutImg.Height);
			srcR := Rect(Round(tmpBmp.Width*(1-fDeg)), 0, tmpBmp.Width, tmpBmp.Height);
			theOutImg.Canvas.CopyRect(dstR, tmpBmp.Canvas, srcR);
		end;
		//
		tmpBmp.FreeImage;
		if (Assigned(Item1) and Assigned(Item1.Image)) then begin
			tmpBmp.Assign(Item1.Image);
			tmpBmp.PixelFormat := theOutImg.PixelFormat;
			dstR := Rect(Round(theOutImg.Width*fDeg)+1, 0, theOutImg.Width, theOutImg.Height);
		  srcR := Rect(0, 0, Round(tmpBmp.Width*(1-fDeg)), tmpBmp.Height);
			theOutImg.Canvas.CopyRect(dstR, tmpBmp.Canvas, srcR);
		end;
	finally
		tmpBmp.Free;
	end;
end;

initialization
	RegisterClasses([TFXItem]);

end.
	