// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'KMSlider.pas' rev: 5.00

#ifndef KMSliderHPP
#define KMSliderHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Messages.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Kmslider
{
//-- type declarations -------------------------------------------------------
typedef Shortint TNumThumbStates;

typedef Shortint TImageArrayRange;

#pragma option push -b-
enum TKMSliderOrientation { soHorizontal, soVertical };
#pragma option pop

#pragma option push -b-
enum TKMSliderOption { soShowFocus, soShowPoints, soSmooth };
#pragma option pop

typedef Set<TKMSliderOption, soShowFocus, soSmooth>  TKMSliderOptions;

#pragma option push -b-
enum TKMSliderImage { siHThumb, siHRuler, siVThumb, siVRuler };
#pragma option pop

typedef Set<TKMSliderImage, siHThumb, siVRuler>  TKMSliderImages;

typedef Graphics::TBitmap* TImageArray[4];

#pragma option push -b-
enum TJumpMode { jmNone, jmHome, jmEnd, jmNext, jmPrior };
#pragma option pop

class DELPHICLASS TKMSlider;
class DELPHICLASS TKMSliderThumb;
class PASCALIMPLEMENTATION TKMSliderThumb : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	Graphics::TBitmap* FBitmap;
	Graphics::TColor FTransparentColor;
	bool FDown;
	TNumThumbStates FNumStates;
	void __fastcall SetBitmap(Graphics::TBitmap* Value);
	void __fastcall SetTransparentColor(Graphics::TColor Value);
	void __fastcall SetDown(bool Value);
	void __fastcall SetNumStates(TNumThumbStates Value);
	void __fastcall AdjustBounds(void);
	
protected:
	__fastcall virtual TKMSliderThumb(Classes::TComponent* AOwner);
	__fastcall virtual ~TKMSliderThumb(void);
	virtual void __fastcall Paint(void);
	
public:
	__property Graphics::TBitmap* Bitmap = {read=FBitmap, write=SetBitmap};
	__property Graphics::TColor TransparentColor = {read=FTransparentColor, write=SetTransparentColor, 
		default=32896};
	__property bool Down = {read=FDown, write=SetDown, default=0};
	__property TNumThumbStates NumStates = {read=FNumStates, write=SetNumStates, default=2};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TKMSliderThumb(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TKMSlider : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	TKMSliderImages FUserImages;
	Graphics::TBitmap* FImages[4];
	int FEdgeSize;
	Graphics::TBitmap* FRuler;
	Windows::TPoint FRulerOrg;
	TKMSliderThumb* FThumb;
	Windows::TRect FPointsRect;
	TKMSliderOrientation FOrientation;
	TKMSliderOptions FOptions;
	int FMinValue;
	int FMaxValue;
	int FIncrement;
	int FValue;
	int FHit;
	bool FActive;
	bool FSliding;
	bool FTracking;
	bool FTimerActive;
	Windows::TPoint FMousePos;
	TJumpMode FStartJump;
	Classes::TNotifyEvent FOnChange;
	Classes::TNotifyEvent FOnDrawPoints;
	Classes::TNotifyEvent FOnStopTracking;
	Graphics::TBitmap* __fastcall GetImage(int Index);
	void __fastcall SetImage(int Index, Graphics::TBitmap* Value);
	void __fastcall SetEdgeSize(int Value);
	TNumThumbStates __fastcall GetNumThumbStates(void);
	void __fastcall SetNumThumbStates(TNumThumbStates Value);
	void __fastcall SetOrientation(TKMSliderOrientation Value);
	void __fastcall SetOptions(TKMSliderOptions Value);
	void __fastcall SetMinValue(int Value);
	void __fastcall SetMaxValue(int Value);
	void __fastcall SetIncrement(int Value);
	int __fastcall GetThumbOffset(void);
	void __fastcall SetThumbOffset(int Value);
	void __fastcall SetValue(int Value);
	void __fastcall ThumbJump(TJumpMode Jump);
	TJumpMode __fastcall JumpTo(int X, int Y);
	void __fastcall StopTracking(void);
	void __fastcall TimerTrack(void);
	bool __fastcall StoreImage(int Index);
	void __fastcall CreateElements(void);
	void __fastcall BuildRuler(void);
	void __fastcall AdjustElements(void);
	void __fastcall ImageChanged(void);
	void __fastcall ReadUserImages(Classes::TStream* Stream);
	void __fastcall WriteUserImages(Classes::TStream* Stream);
	int __fastcall GetValueByOffset(int Offset);
	int __fastcall GetOffsetByValue(int Value);
	int __fastcall GetRulerLength(void);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Msg);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	MESSAGE void __fastcall WMTimer(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFocusChanged(Controls::TCMFocusChanged &Message);
	__property int ThumbOffset = {read=GetThumbOffset, write=SetThumbOffset, nodefault};
	
protected:
	DYNAMIC void __fastcall Change(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall Paint(void);
	virtual void __fastcall ThumbMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	virtual void __fastcall ThumbMouseMove(System::TObject* Sender, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall ThumbMouseUp(System::TObject* Sender, Controls::TMouseButton Thumb, Classes::TShiftState 
		Shift, int X, int Y);
	
public:
	__fastcall virtual TKMSlider(Classes::TComponent* AOwner);
	__fastcall virtual ~TKMSlider(void);
	virtual void __fastcall DefaultDrawPoints(int PointsStep, int PointsHeight, int ExtremePointsHeight
		);
	__property Canvas ;
	
__published:
	__property Graphics::TBitmap* ImageHThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=0
		};
	__property Graphics::TBitmap* ImageHRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=1
		};
	__property Graphics::TBitmap* ImageVThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=2
		};
	__property Graphics::TBitmap* ImageVRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=3
		};
	__property int EdgeSize = {read=FEdgeSize, write=SetEdgeSize, default=2};
	__property TNumThumbStates NumThumbStates = {read=GetNumThumbStates, write=SetNumThumbStates, nodefault
		};
	__property TKMSliderOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
		
	__property TKMSliderOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property int Increment = {read=FIncrement, write=SetIncrement, nodefault};
	__property int MinValue = {read=FMinValue, write=SetMinValue, nodefault};
	__property int MaxValue = {read=FMaxValue, write=SetMaxValue, nodefault};
	__property int Value = {read=FValue, write=SetValue, nodefault};
	__property Align ;
	__property Visible ;
	__property Enabled ;
	__property Color ;
	__property Cursor ;
	__property DragMode ;
	__property DragCursor ;
	__property ParentColor ;
	__property ParentShowHint ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnDrawPoints = {read=FOnDrawPoints, write=FOnDrawPoints};
	__property Classes::TNotifyEvent OnStopTracking = {read=FOnStopTracking, write=FOnStopTracking};
	__property OnClick ;
	__property OnDblClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnKeyDown ;
	__property OnKeyUp ;
	__property OnKeyPress ;
	__property OnDragOver ;
	__property OnDragDrop ;
	__property OnEndDrag ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TKMSlider(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Kmslider */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Kmslider;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// KMSlider
