// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'KMTimeLineTypes.pas' rev: 5.00

#ifndef KMTimeLineTypesHPP
#define KMTimeLineTypesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Contnrs.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Kmtimelinetypes
{
//-- type declarations -------------------------------------------------------
typedef double TTBRTime;

typedef Extended TSeconds;

#pragma option push -b-
enum TTimeBarResolution { tbr1Frame, tbr2Frames, tbr4Frames, tbrQrtSec, tbrHalfSec, tbr1Sec, tbt2Secs, 
	tbr4Secs, tbr10Secs, tbr20Secs, tbr1Min, tbr2Mins, tbr10Mins, tbr30Mins };
#pragma option pop

#pragma option push -b-
enum TKMTrackItemSpecs { tisLeftRes, tisRightRes, tisSaveDur, tisSelectable, tisFixedDuration, tisPrevConnected, 
	tisMoveable };
#pragma option pop

typedef Windows::TPoint TSelectedPtArr[6];

struct TKMTimeLineData
{
	unsigned PanTop;
	unsigned PanBottom;
	unsigned PanLeftPos;
	unsigned PanRightPos;
	bool RightCtrlsVisible;
	unsigned AbsPanStartTime;
	TTimeBarResolution CurTBR;
	Word FramesPS;
	int TimeUnitWidth;
	int TimeGranulation;
} ;

#pragma option push -b-
enum TItemCursorPos { dicpOut, dicpIn, dicpStart, dicpEnd };
#pragma option pop

#pragma option push -b-
enum TChgReaction { chgrRightAway, chgrUponNextCh };
#pragma option pop

#pragma option push -b-
enum TChangeItem { cgtiNone, cgtiSelected, cgtiStart, cgtiEnd, cgtiMove, cgtiLTrim, cgtiRTrim, cgtiLCut, 
	cgtiRCut };
#pragma option pop

typedef TChangeItem TAlterChgItem;

#pragma option push -b-
enum TChgItemMode { dicmMouseMove, dicmMouseDown, dicmMouseUp, dicmScroll };
#pragma option pop

#pragma option push -b-
enum TScrollDir { scrlNone, scrlLeft, scrlRight };
#pragma option pop

typedef short TKMTrackTypeID;

class DELPHICLASS TKMTrackType;
class PASCALIMPLEMENTATION TKMTrackType : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TKMTrackTypeID FKMTrackTypeID;
	Graphics::TBitmap* FImage;
	Graphics::TColor FColor;
	bool FParentColor;
	AnsiString FName;
	void __fastcall SetColor(Graphics::TColor theColor);
	void __fastcall SetImage(Graphics::TBitmap* theImage);
	
public:
	__fastcall virtual TKMTrackType(Classes::TComponent* AOwner);
	__fastcall virtual ~TKMTrackType(void);
	__property Graphics::TBitmap* Image = {read=FImage, write=SetImage};
	
__published:
	__property TKMTrackTypeID KMTrackTypeID = {read=FKMTrackTypeID, write=FKMTrackTypeID, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, nodefault};
	__property bool ParentColor = {read=FParentColor, write=FParentColor, nodefault};
	__property AnsiString Name = {read=FName, write=FName};
};


typedef TComponentList TKMTrackTypeArr;
;

class DELPHICLASS TKMTrackTypes;
class PASCALIMPLEMENTATION TKMTrackTypes : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Contnrs::TComponentList* FKMTrackTypeArr;
	void __fastcall SetCount(int theCount);
	int __fastcall GetCount(void);
	TKMTrackType* __fastcall GetKMTrackTypeArr(int Index);
	
public:
	__fastcall virtual TKMTrackTypes(Classes::TComponent* AOwner);
	__fastcall virtual ~TKMTrackTypes(void);
	void __fastcall Delete(int Index);
	int __fastcall Add(TKMTrackType* theKMLType);
	__property TKMTrackType* Items[int Index] = {read=GetKMTrackTypeArr};
	__property int Count = {read=GetCount, write=SetCount, nodefault};
};


typedef DynamicArray<TKMTrackTypeID >  TKMTrackTypeIDs;

typedef DynamicArray<int >  TKMTrackTypeIndexes;

typedef int TKMTrackID;

struct TItemChangeData
{
	TChangeItem ChangeItem;
	TChangeItem ChgItemStBy;
	Windows::TPoint LastPtPos;
	double LinePos;
	int InPos;
	Extended StartLimit;
	Extended EndLimit;
	TKMTrackTypeID ChangeTrackID;
} ;

struct TCanvasSaveState
{
	Graphics::TColor FPenColor;
	Graphics::TPenMode FPenMode;
	Graphics::TPenStyle FPenStyle;
	int FPenWidth;
	Graphics::TColor FBrushColor;
	Graphics::TBrushStyle FBrushStyle;
	Graphics::TColor FFontColor;
	int FFontHeight;
	AnsiString FFontName;
	Graphics::TFontStyles FFontStyle;
} ;

typedef DynamicArray<Windows::TRect >  TRectArr;

//-- var, const, procedure ---------------------------------------------------
static const Shortint c_CustomTrackTypeIDBase = 0x10;
static const TKMTrackTypeID c_NoTrackTypeID = 0xffffffff;
extern PACKAGE TKMTrackTypeID c_BlockTrackTypeID;
extern PACKAGE AnsiString c_BlockTrackTypeName;
static const Word c_CustomTrackIDBase = 0x100;
#define c_CustomTrackNameBase "KMTrack"
static const int c_NoTrackID = 0xffffffff;
extern PACKAGE TKMTrackID c_BlockTrackID;
extern PACKAGE AnsiString c_BlockTrackName;
static const Shortint crLTrimPos = 0xa;
static const Shortint crRTrimPos = 0xb;
static const Shortint crLTrimCut = 0xc;
static const Shortint crRTrimCut = 0xe;
#define c_KMTimeLineVersion1  (1.000000E+00)
#define c_ActTimeInit  (-1.000000E+00)
extern PACKAGE System::SmallString<10>  TimeBarResolutionStr[14];
static const Shortint c_tmrScroll = 0x1;
static const Shortint c_tmrSelect = 0x2;
static const Shortint c_TimeBarHeight = 0x1c;
static const Shortint c_TimeGridVPos = 0x0;
static const Shortint c_TimeGridHeight = 0x8;
static const Shortint c_TimeTextVPos = 0x8;
static const Shortint c_TimeTextHeight = 0xc;
static const Shortint c_MarkerVPos = 0x14;
static const Shortint c_MarkerHeight = 0x8;
static const Shortint c_CtrlsPanHeight = 0x15;
static const Shortint c_interPanGap = 0x2;
static const Shortint c_initLeftOfTrackWidth = 0x18;
static const Shortint c_initRightOfTrackWidth = 0x14;
static const Shortint c_RightCtlsPanWidth = 0x15;
static const Shortint c_SysToolbarBtnCnt = 0x1;
static const Shortint c_SysTBImgIndex = 0x2;
static const Shortint c_SysToolbarBtnGap = 0x4;
static const Shortint c_ToolbarBtnCntInit = 0x0;
static const Shortint c_ToolbarBtnCntMax = 0x14;
static const int c_TimeBarColor = 0xff00;
static const int c_TimeBarMarkColor = 0x800000;
static const int c_MarkerColor = 0xffff00;
static const int c_MarkerTrackColor = 0x808000;
static const Shortint c_MarkerWidth = 0x6;
static const Shortint c_MinMarkerWidth = 0x3;
static const Shortint c_MaxMarkerWidth = 0xf;
static const Shortint c_imgSize = 0x10;
extern PACKAGE System::Set<TChangeItem, cgtiNone, cgtiRCut>  Delayed_ChgItemReaction_Set;
extern PACKAGE System::Set<TChangeItem, cgtiNone, cgtiRCut>  Cancel_ItemChangeIfOut_Set;
extern PACKAGE System::Set<TChangeItem, cgtiNone, cgtiRCut>  Scroll_ChgItem_Set;
extern PACKAGE System::Set<TAlterChgItem, cgtiLTrim, cgtiRCut>  Alter_ChgItem_Set;
extern PACKAGE System::Set<TChangeItem, cgtiNone, cgtiRCut>  ItemChangeModeStartArr[4];
extern PACKAGE System::Set<TChangeItem, cgtiNone, cgtiRCut>  ItemChangeModeEndArr[4];
extern PACKAGE TChangeItem CursorPos_ChgItem_Link[4];
extern PACKAGE Controls::TCursor CursorShape_Pos_Link[4];
extern PACKAGE Controls::TCursor CursorShape_ChgItem_Link[9];
extern PACKAGE TChangeItem __fastcall Alter_KeyDown_ChgItem_Link(Word Key, TChangeItem theChgItem);
extern PACKAGE TChangeItem __fastcall Alter_KeyPress_ChgItem_Link(Word Key, TChangeItem theChgItem);
	
extern PACKAGE TChangeItem __fastcall Alter_KeyUp_ChgItem_Link(Word Key, TChangeItem theChgItem);
extern PACKAGE bool __fastcall Between(double ckVal, double Val1, double Val2);
extern PACKAGE Shortint __fastcall GetSign(int theNum);
extern PACKAGE unsigned __fastcall MaxIntVal(const int * theIntArr, const int theIntArr_Size);
extern PACKAGE unsigned __fastcall MinIntVal(const int * theIntArr, const int theIntArr_Size);
extern PACKAGE int __fastcall Ceiling(double theDoub);
extern PACKAGE void __fastcall SaveCanvasState(Graphics::TCanvas* theCanvas, TCanvasSaveState &theCanvasState
	);
extern PACKAGE void __fastcall RestoreCanvasState(Graphics::TCanvas* theCanvas, const TCanvasSaveState 
	&theCanvasState);
extern PACKAGE TKMTrackTypeIDs __fastcall KMTrackTypeIDs(const TKMTrackTypeID * theKMLTypeIDs, const 
	int theKMLTypeIDs_Size);

}	/* namespace Kmtimelinetypes */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Kmtimelinetypes;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// KMTimeLineTypes
