// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'KMTrack.pas' rev: 5.00

#ifndef KMTrackHPP
#define KMTrackHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <KMTimeLineTypes.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <KMTrackItem.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Kmtrack
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TKMTrack;
class PASCALIMPLEMENTATION TKMTrack : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Kmtimelinetypes::TKMTrackID FID;
	Kmtrackitem::TKMTrackItem* FItemListHead;
	Kmtrackitem::TKMTrackItem* FCurrentItem;
	int FTrackTop;
	int FTrackBottom;
	int FTrackSplit;
	Graphics::TBitmap* FTrackImage;
	int FFixedHeight;
	DynamicArray<int >  FKMTrackTypeIndexes;
	bool FActive;
	Graphics::TColor FColor;
	bool FParentColor;
	AnsiString FName;
	Extended FSelStart;
	Extended FSelEnd;
	void __fastcall SetColor(Graphics::TColor theColor);
	void __fastcall SetParentColor(bool theParentClr);
	void __fastcall DoInitKMTrack(Kmtimelinetypes::TKMTrackID theID, AnsiString theName);
	
protected:
	Graphics::TBitmap* __fastcall GetKMTrackImage(void);
	void __fastcall SetKMTrackImage(Graphics::TBitmap* theImg);
	virtual bool __fastcall GetActive(void);
	virtual void __fastcall SetActive(bool theActive);
	void __fastcall SetFixedHeight(int theFixHeight);
	void __fastcall DoLoadKMTrack(Classes::TStream* theStream);
	void __fastcall DoStoreKMTrack(Classes::TStream* theStream);
	virtual void __fastcall DefineProperties(Classes::TFiler* theFiler);
	Classes::TComponent* __fastcall GetKMTimeLineOwner(void);
	virtual Windows::TRect __fastcall GetTrackShowingRect(void);
	virtual Windows::TRect __fastcall GetTrackVisibleRect(void);
	
public:
	__fastcall virtual TKMTrack(Classes::TComponent* AOwner);
	__fastcall TKMTrack(Classes::TComponent* AOwner, Kmtimelinetypes::TKMTrackID theID, AnsiString theName
		);
	__fastcall virtual ~TKMTrack(void);
	bool __fastcall ItemCompatible(Kmtrackitem::TKMTrackItem* theKMItem);
	bool __fastcall TrackTypeCompatible(Kmtimelinetypes::TKMTrackTypeID theTrackTypeID)/* overload */;
	bool __fastcall TrackTypeCompatible(AnsiString theTrackTypeName)/* overload */;
	void __fastcall GetSelPtArr(Windows::TPoint * theSelPtArr);
	__property Kmtrackitem::TKMTrackItem* ItemListHead = {read=FItemListHead, write=FItemListHead};
	__property Kmtrackitem::TKMTrackItem* CurrentItem = {read=FCurrentItem, write=FCurrentItem};
	__property int TrackTop = {read=FTrackTop, write=FTrackTop, nodefault};
	__property int TrackBottom = {read=FTrackBottom, write=FTrackBottom, nodefault};
	__property int TrackSplit = {read=FTrackSplit, write=FTrackSplit, nodefault};
	__property Kmtimelinetypes::TKMTrackTypeIndexes KMTrackTypeIndexes = {read=FKMTrackTypeIndexes, write=
		FKMTrackTypeIndexes};
	__property Classes::TComponent* KMTimeLine = {read=GetKMTimeLineOwner};
	__property Graphics::TBitmap* Image = {read=GetKMTrackImage, write=SetKMTrackImage};
	__property Extended SelStart = {read=FSelStart, write=FSelStart};
	__property Extended SelEnd = {read=FSelEnd, write=FSelEnd};
	__property Windows::TRect TrackVisibleRect = {read=GetTrackVisibleRect};
	__property Windows::TRect TrackShowingRect = {read=GetTrackShowingRect};
	
__published:
	__property Kmtimelinetypes::TKMTrackID ID = {read=FID, write=FID, nodefault};
	__property bool Active = {read=GetActive, write=SetActive, nodefault};
	__property int FixedHeight = {read=FFixedHeight, write=SetFixedHeight, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, nodefault};
	__property bool ParentColor = {read=FParentColor, write=SetParentColor, nodefault};
	__property AnsiString Name = {read=FName, write=FName};
};


class DELPHICLASS TKMTrackList;
class PASCALIMPLEMENTATION TKMTrackList : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Contnrs::TComponentList* FTracksList;
	
protected:
	int __fastcall Getcount(void);
	TKMTrack* __fastcall GetItem(int Index);
	
public:
	__fastcall virtual TKMTrackList(Classes::TComponent* AOwner);
	__fastcall virtual ~TKMTrackList(void);
	void __fastcall Add(TKMTrack* theKMTrack);
	HIDESBASE void __fastcall Insert(TKMTrack* theKMTrack, int Index);
	void __fastcall Delete(int Index);
	int __fastcall IndexOf(TKMTrack* theKMTrack);
	void __fastcall Move(int CurIndex, int NewIndex);
	__property int Count = {read=Getcount, nodefault};
	__property TKMTrack* Items[int Index] = {read=GetItem/*, default*/};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Kmtrack */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Kmtrack;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// KMTrack
